Package: dyn
Version: 0.2-9.6
Date: 2018-03-18
Title: Time Series Regression
Author: G. Grothendieck
Maintainer: M. Leeds <markleeds2@gmail.com>
Description: Time series regression.  The dyn class interfaces ts,
        irts(), zoo() and zooreg() time series classes to lm(), glm(),
        loess(), quantreg::rq(), MASS::rlm(), MCMCpack::MCMCregress(),
        quantreg::rq(), randomForest::randomForest() and other regression
        functions allowing those functions to be used with time series
        including specifications that may contain lags, diffs and
        missing values.
Depends: R (>= 2.6.0), zoo (>= 1.0-0)
Suggests: lattice, MASS, MCMCpack, quantreg (>= 3.82), randomForest,
        sandwich, tseries
License: GPL
Packaged: 2018-03-19 05:44:27 UTC; home
Repository: CRAN
Date/Publication: 2018-03-19 06:14:06 UTC
NeedsCompilation: no
Built: R 4.6.0; ; 2026-04-27 08:55:15 UTC; unix

exportPattern(".")
import(zoo)
importFrom("stats", "anova", "fitted", "formula", "frequency",
           "model.frame", "model.matrix", "na.omit", "predict",
           "resid", "residuals", "terms", "time")
S3method(anova,dyn)
S3method(fitted,dyn)
S3method(fitted,irts)
S3method(fitted,its)
S3method(fitted,ts)
S3method(fitted,zoo)    
S3method(fitted,zooreg)
S3method(model.frame,dyn)
S3method(model.frame,irts)
S3method(model.frame,its)
S3method(model.frame,ts)
S3method(model.frame,zoo)
S3method(model.frame,zooreg)
S3method(model.matrix,dyn)
S3method(predict,dyn)
S3method(predict,irts)
S3method(predict,its)
S3method(predict,ts)
S3method(predict,zoo)
S3method(predict,zooreg)
S3method(residuals,dyn)
S3method(residuals,irts)
S3method(residuals,its)
S3method(residuals,ts)
S3method(residuals,zoo)
S3method(residuals,zooreg)
S3method(update,dyn)
S3method("$",dyn)

[![Actions Status](https://github.com/sanko/Dyn.pm/actions/workflows/linux.yaml/badge.svg)](https://github.com/sanko/Dyn.pm/actions) [![Actions Status](https://github.com/sanko/Dyn.pm/actions/workflows/windows.yaml/badge.svg)](https://github.com/sanko/Dyn.pm/actions) [![Actions Status](https://github.com/sanko/Dyn.pm/actions/workflows/osx.yaml/badge.svg)](https://github.com/sanko/Dyn.pm/actions) [![Actions Status](https://github.com/sanko/Dyn.pm/actions/workflows/freebsd.yaml/badge.svg)](https://github.com/sanko/Dyn.pm/actions) [![MetaCPAN Release](https://badge.fury.io/pl/Dyn.svg)](https://metacpan.org/release/Dyn)
# NAME

Dyn - dyncall-Backed FFI Building Blocks

# SYNOPSIS

```perl
use Dyn qw[:dc :dl]; # Imports all functions from Dyn::Call and Dyn::Load
```

# DESCRIPTION

Dyn is a wrapper around [dyncall](https://dyncall.org/). It's here for the sake
of convenience.

This distribution includes...

- [Dyn::Call](https://metacpan.org/pod/Dyn%3A%3ACall)

    An encapsulation of architecture-, OS- and compiler-specific function call
    semantics.

    Functions can be imported with the `:dc` tag.

- [Dyn::Callback](https://metacpan.org/pod/Dyn%3A%3ACallback)

    Callback interface of `dyncall` located in `dyncallback`.

    Functions can be imported with the `:dcb` tag.

- [Dyn::Load](https://metacpan.org/pod/Dyn%3A%3ALoad)

    Facilitates portable library symbol loading and access to functions in foreign
    dynamic libraries and code modules.

    Functions can be imported with the `:dl` tag.

# Signatures

`dyncall` uses an almost `pack`-like syntax to define signatures. A signature
is a character string that represents a function's arguments and return value
types. This is an essential part of mapping the more flexible and often
abstract data types provided in scripting languages to the strict machine-level
data types used by C-libraries.

Here are some signature examples along with their equivalent C function
prototypes:

```
dyncall signature    C function prototype
--------------------------------------------
)v                   void      f1 ( )
ii)i                 int       f2 ( int, int )
p)L                  long long f3 ( void * )
p)v                  void      f4 ( int ** )
iBcdZ)d              double    f5 ( int, bool, char, double, const char * )
_esl_.di)v           void      f6 ( short a, long long b, ... ) (for (promoted) varargs: double, int)
(Zi)i                int       f7 ( const char *, int )
(iiid)v              void      f8 ( int, int, int, double )
```

The following types are supported:

```
Signature character     C/C++ data type
----------------------------------------------------
v                       void
B                       _Bool, bool
c                       char
C                       unsigned char
s                       short
S                       unsigned short
i                       int
I                       unsigned int
j                       long
J                       unsigned long
l                       long long, int64_t
L                       unsigned long long, uint64_t
f                       float
d                       double
p                       void *
Z                       const char * (pointer to a C string)
A                       aggregate (struct/union described out-of-band via DCaggr)
```

See [Dyn::Call](https://metacpan.org/pod/Dyn%3A%3ACall#Signature) for importable values.

Please note that using a `(` at the beginning of a signature string is
possible, although not required. The character doesn't have any meaning and
will simply be ignored. However, using it prevents annoying syntax highlighting
problems with some code editors.

Calling convention modes can be switched using the signature string, as well.
An `_` in the signature string is followed by a character specifying what
calling convention to use, as this effects how arguments are passed. This makes
only sense if there are multiple co-existing calling conventions on a single
platform. Usually, this is done at the beginning of the string, except in
special cases, like specifying where the varargs part of a variadic function
begins. The following signature characters exist:

```
Signature character   Calling Convention
------------------------------------------------------
:                     platform's default calling convention
*                     C++ this calls (platform native)
e                     vararg function
.                     vararg function's variadic/ellipsis part (...), to be specified before first vararg
c                     only on x86: cdecl
s                     only on x86: stdcall
F                     only on x86: fastcall (MS)
f                     only on x86: fastcall (GNU)
+                     only on x86: thiscall (MS)
#                     only on x86: thiscall (GNU)
A                     only on ARM: ARM mode
a                     only on ARM: THUMB mode
$                     syscall
```

See [Dyn::Call](https://metacpan.org/pod/Dyn%3A%3ACall#Modes) for importable values.

# Platform Support

The dyncall library runs on many different platforms and operating systems
(including Windows, Linux, OpenBSD, FreeBSD, macOS, DragonFlyBSD, NetBSD,
Plan9, iOS, Haiku, Nintendo DS, Playstation Portable, Solaris, Minix, Raspberry
Pi, ReactOS, etc.) and processors (x86, x64, arm (arm & thumb mode), arm64,
mips, mips64, ppc32, ppc64, sparc, sparc64, etc.).

# See Also

[https://dyncall.org](https://dyncall.org)

[Affix](https://metacpan.org/pod/Affix) for a dyncall wrapper with some of the rough edges sanded down.

[FFI::Platypus](https://metacpan.org/pod/FFI%3A%3APlatypus) for a mature, well-tested FFI.

# LICENSE

Copyright (C) Sanko Robinson.

This library is free software; you can redistribute it and/or modify it under
the terms found in the Artistic License 2. Other copyrights, terms, and
conditions may apply to data transmitted through this module.

# AUTHOR

Sanko Robinson <sanko@cpan.org>

dyn is an R package that facilitates the use of regression
using time series data with lags and diffs (known as dynamic
regression).  It is a lightweight package that has no
facilities of its own but leverages off the various time
series and regression functions in R to make it easier to
use them together.

Its features include:

- many regression functions.  It can be used with lm, glm,
  loess, rq, randomForest, lqs, rlm and any other regression 
  functions that use model.frame and are written in the
  style of lm.

- many time series classes. It can be used with ts, zooreg,
  zoo, its, and irts time series classes.  This covers
  regular, weakly regular and irregular time series classes.

- missing values.  Time series may have missing values including
  internal missing values.  Both na.omit and na.exclude are
  supported.  

- good citizen.  It does not replace the regression
  functions but rather works with them by providing new
  methods to the standard R generics: model.frame, resid,
  fitted, predict, update, anova and $.

- ease of use.  dyn enables one to use the same regression
  functions (lm, glm, etc.) using the same syntax one has
  always used.  Just preface the regression function name with 
  dyn$ and it is transformed into a regression function that 
  can handle time series:

   dyn$lm( y ~ x + lag(x) + diff(w) )     # lm
   dyn$loess( y ~ x + lag(x) + diff(w) )  # loess

- modular.  dyn can be used with any regression function that
  uses model.frame and is written in the style of lm.  Additional
  classes can be added to dyn simply by adding new methods. dyn
  is modular so such updates can be made without changing dyn, 
  itself. 

- documentation.  It includes a help page and six demos.

   ?dyn                   # help file
   demo(package = "dyn")  # list of demos
   demo("dyn-rq")         # runs indicated dyn demo

   # other information
   file.show(system.file("NEWS", package = "dyn"))  
   file.show(system.file("README", package = "dyn") # this file
   file.show(system.file("THANKS", package = "dyn"))
   file.show(system.file("WISHLIST", package = "dyn"))

The package is available on CRAN.  Comments/questions welcome.

library(dyn)
library(quantreg)

# create zoo series from airquality Ozone column
ozone.z <- zoo(airquality[,"Ozone"])

# quantile regression of ozone on one day lag
ozone.rq <- dyn$rq(ozone.z ~ lag(ozone.z,-1), 0:10/10)

# ML: TAKEN OUT ON 12-12-16
# plot data and overlay quantile regression lines
## plot(formula(ozone.rq), pch = 20)
## apply(coef(ozone.rq), 2, abline)

# plot each coefficient vs. tau, one graph per coefficient
plot(zoo(t(coef(ozone.rq)), ozone.rq$tau), xlab = "tau", main = "ozone")

# convert freeny data set to a zooreg series (without the lag column)
data(freeny)
library(dyn)
freeny.z <- zooreg(cbind(y = as.vector(freeny.y), freeny.x[,-1]),
		start = start(freeny.y), freq = frequency(freeny.y))

freeny.lm <- dyn$lm(y ~ lag(y,-1) + ., freeny.z)
summary(freeny.lm)

y <- freeny.z[,"y"]
y.fit <- fitted(freeny.lm)
plot(merge(y, y.fit), col = 1:2, plot = "single")

library(quantreg)
freeny.rq <- dyn$rq(y ~ lag(y,-1) + ., freeny.z, tau = 1:9/10)
freeny.rq
plot(zoo(t(coef(freeny.rq)), freeny.rq$tau), main = "freeny", xlab = "tau")
head(resid(freeny.rq))

library(dyn)
set.seed(1)
x <- matrix(rnorm(40), ncol = 2, dimnames = list(NULL,c("gdp", "ipi")))
x[1:10,2]<-NA

x.ts <- ts(x, start = 1950, freq = 4)

x.ts.lm <- dyn$lm(gdp ~ lag(gdp, -2) + lag(ipi, -1), data = x.ts, 
	na.action = na.exclude)

resid(x.ts.lm)
fitted(x.ts.lm)

library(dyn)

cat("# create some data\n")
set.seed(1)
x <- matrix(rnorm(40), ncol = 2, dimnames = list(NULL, c("gdp", "ipi")))
x.ts <- ts(x, start = 1950, freq = 4)


cat("Run a dynamic regression\n")
x.ts.lm <- dyn$lm(gdp ~ lag(gdp, -2) + lag(ipi,-1), data = x.ts)

resid(x.ts.lm)
fitted(x.ts.lm)

x.pred <- predict(x.ts.lm, x.ts)
x.pred

cat("Plot gdp in black and predicted gdp in red\n")
ts.plot( x.ts[,"gdp"], x.pred, 
	gpars = list(type = "b", col = 1:2, pch = 20))


cat("Run demo() to find names of additional dyn demos\n")

library(dyn)
data(airquality)
start.date <- as.Date(paste(c(1973, airquality[1,5:6]), collapse = "-")) 
airquality.zoo <- zooreg(data.matrix(airquality), start = start.date)

ozone.lm <- dyn$lm(Ozone ~ ., airquality.zoo, na.action = na.omit)
ozone.lm
head(fitted(ozone.lm))
head(resid(ozone.lm))

ozone2.lm <- dyn$lm(Ozone ~ ., airquality.zoo, na.action = na.exclude)
ozone2.lm
head(fitted(ozone.lm))
head(resid(ozone.lm))

end. <- time(airquality.zoo)[140]

# subset
ozone3.lm <- dyn$lm(Ozone[time(Ozone) < end.] ~ lag(Ozone, -1), airquality.zoo)
ozone3.lm

# alternative subset
ozone4.lm <- dyn$lm(window(Ozone, end = end.) ~ lag(Ozone, -1), airquality.zoo)
ozone4.lm

# one step ahead prediction

# test data
set.seed(1)
y <- ts(rnorm(10, 1:10, 0.1))

# fit model
library(dyn)
y.lm <- dyn$lm(y ~ lag(y,-1))

# use predict
tail(predict(y.lm, y), 1)

# or multiply by coefficients giving same result
coef(y.lm) %*% c(1, tail(y,1))

# Now try it using quantile regression
library(quantreg)
y.rq <- dyn$rq(y ~ lag(y,-1))
tail(predict(y.rq, y), 1)
coef(y.rq) %*% c(1, tail(y,1))

=pod

=encoding utf-8

=head1 NAME

Dyn::Callback::Args - dyncall args C API

=head1 DESCRIPTION

dyncall args provides serialized access to arguments of a function call.

These functions are used in hand rolled Dyn::Callback systems.

=head1 Methods

This package exposes the following functions...

=head2 C<dcbArgBool( $args )>

Returns the next value on the stack and assumes it is a C<bool>.

=head2 C<dcbArgChar( $args )>

Returns the next value on the stack and assumes it is a C<char>.

=head2 C<dcbArgUChar( $args )>

Returns the next value on the stack and assumes it is an C<unsigned char>.

=head2 C<dcbArgShort( $args )>

Returns the next value on the stack and assumes it is a C<short>.

=head2 C<dcbArgUShort( $args )>

Returns the next value on the stack and assumes it is a C<unsigned short>.

=head2 C<dcbArgInt( $args )>

Returns the next value on the stack and assumes it is an C<int>.

=head2 C<dcbArgUInt( $args )>

Returns the next value on the stack and assumes it is an C<unsigned int>.

=head2 C<dcbArgLong( $args )>

Returns the next value on the stack and assumes it is a C<long>.

=head2 C<dcbArgULong( $args )>

Returns the next value on the stack and assumes it is a C<unsigned long>.

=head2 C<dcbArgLongLong( $args )>

Returns the next value on the stack and assumes it is a C<long long>.

=head2 C<dcbArgULongLong( $args )>

Returns the next value on the stack and assumes it is an C<unsigned long long>.

=head2 C<dcbArgFloat( $args )>

Returns the next value on the stack and assumes it is a C<float>.

=head2 C<dcbArgDouble( $args )>

Returns the next value on the stack and assumes it is a C<double>.

=head2 C<dcbArgPointer( $args )>

Returns the next value on the stack and assumes it is a pointer (C<void *>).

=head2 C<dcbArgAggr( $args, $target )>

Returns the next value on the stack and assumes it is an aggregate.

For trivial aggrs, C<$target> points to space to copy the aggregate to, and
C<$target> is returned.

For C++ non-trivial aggrs, C<$target> is ignored, and a pointer to the
aggregate is returned.

=head2 C<dcbArgString( $args )>

Returns the next value on the stack and assumes it is a string (C<const char
*>).

=head2 C<dcbReturnAggr( $args, $result, $ret )>

This is a helper function to put a to be returned struct-by-value into the
C<$result> param of the callback handler; for C++ non-trivial aggrs, pass
C<undef> in C<$ret>, then copy the aggregate into C<< $result-E<gt>p >>.

=head1 LICENSE

Copyright (C) Sanko Robinson.

This library is free software; you can redistribute it and/or modify it under
the terms found in the Artistic License 2. Other copyrights, terms, and
conditions may apply to data transmitted through this module.

=head1 AUTHOR

Sanko Robinson E<lt>sanko@cpan.orgE<gt>

=begin stopwords

dyncall aggrs const

=end stopwords

=cut

=pod

=encoding utf-8

=head1 NAME

Dyn::Callback::Value - dyncall value variant

=head1 DESCRIPTION

Value variant union-type that carries all supported dyncall types.

=head1 Methods

This package is object oriented and brings along the following methods...

=head2 C<new( )>

    my $value = Dyn::Callback::Value->new();

Generates a new Dyn::Callback::Value object.

=head2 C<B( [...] )>

    if ( $value->B ) { ... }
    $value->B( !0 );

Gets and potentially sets the boolean value of the underlying union.

=head2 C<c( [...] )>

    if ( $value->c ) { ... }
    $value->c( ord 'a' );

Gets and potentially sets the char value of the underlying union.

=head2 C<C( [...] )>

    if ( $value->C ) { ... }
    $value->C( ord 'a' );

Gets and potentially sets the unsigned char value of the underlying union.

=head2 C<s( [...] )>

    if ( $value->s == -5 ) { ... }
    $value->s( -16 );

Gets and potentially sets the short value of the underlying union.

=head2 C<S( [...] )>

    if ( $value->S > 3 ) { ... }
    $value->S( 44 );

Gets and potentially sets the unsigned short value of the underlying union.

=head2 C<i( [...] )>

    if ( $value->i == -5 ) { ... }
    $value->i( -16 );

Gets and potentially sets the int value of the underlying union.

=head2 C<I( [...] )>

    if ( $value->I > 3 ) { ... }
    $value->I( 44 );

Gets and potentially sets the unsigned int value of the underlying union.

=head2 C<j( [...] )>

    if ( $value->j == -5 ) { ... }
    $value->j( -16 );

Gets and potentially sets the long value of the underlying union.

=head2 C<J( [...] )>

    if ( $value->J > 3 ) { ... }
    $value->J( 44 );

Gets and potentially sets the unsigned long value of the underlying union.

=head2 C<l( [...] )>

    if ( $value->l == -5 ) { ... }
    $value->j( -16 );

Gets and potentially sets the long long value of the underlying union.

=head2 C<L( [...] )>

    if ( $value->L > 3 ) { ... }
    $value->L( 44 );

Gets and potentially sets the unsigned long long value of the underlying union.

=head2 C<f( [...] )>

    if ( $value->f == -5 ) { ... }
    $value->f( -16 );

Gets and potentially sets the float value of the underlying union.

=head2 C<d( [...] )>

    if ( $value->d > 3 ) { ... }
    $value->d( 44 );

Gets and potentially sets the double value of the underlying union.

=head2 C<p( [...] )>

    if ( $value->p ) { ... }
    $value->p( $window );

Gets and potentially sets the void pointer value of the underlying union.

=head2 C<Z( [...] )>

    if ( $value->Z eq 'Keep things going.' ) { ... }
    $value->Z( 'Do you know?' );

Gets and potentially sets the const char pointer (...a string) value of the
underlying union.

=head1 LICENSE

Copyright (C) Sanko Robinson.

This library is free software; you can redistribute it and/or modify it under
the terms found in the Artistic License 2. Other copyrights, terms, and
conditions may apply to data transmitted through this module.

=head1 AUTHOR

Sanko Robinson E<lt>sanko@cpan.orgE<gt>

=begin stopwords

dyncall const

=end stopwords

=cut

=pod

=encoding utf-8

=head1 NAME

Dyn::Call::Pointer - dyncall variant pointer

=head1 SYNOPSIS

    use Dyn::Call qw[:memory];
    my $ptr = malloc( 10 ); # <--- This is a Dyn::Call::Pointer
    memmove( $ptr, 'Hello, world', 12 );
    free( $ptr );

=head1 DESCRIPTION

It's a void pointer. Make whatever you want with it.

=head1 Functions

Most Dyn::Call::Pointer objects will be generated by dyncall and used
internally but you may use C<malloc( ... )> or C<calloc( ... )> to create one
for your own use.

=head2 C<malloc( $size )>

Allocates C<$size> bytes of uninitialized storage.

    my $value1 = malloc( 10 ); # space for 10 bytes

On success, a new Dyn::Call::Pointer object is returned. To avoid a memory
leaks, the returned pointer must be deallocated with C<free( ... )> or
C<realloc( ... )>.

Failure results in C<undef>.

=head2 C<calloc( $num, $size )>

Allocates memory for an array of C<$num> objects of C<$size> and initializes
all bytes in the allocated storage to zero.

    my $value2 = calloc( 50, 1 ); # space for 50 chars

On success, a new Dyn::Call::Pointer object is returned. To avoid a memory
leaks, the returned pointer must be deallocated with C<free( ... )> or
C<realloc( ... )>.

Failure results in C<undef>.

=head2 C<realloc( $ptr, $new_size )>

Reallocates the given area of memory. It must be previously allocated by
C<malloc( ... )>, C<calloc( ... )> or C<realloc( ... )> and not yet freed with
a call to C<free( ... )> or C<realloc( ... )>.

    my $value3 = realloc( $value2, 1024 );

On success, a new Dyn::Call::Pointer object is returned. To avoid a memory
leaks, the returned pointer must be deallocated with C<free( ... )> or
C<realloc( ... )>.

Failure results in C<undef>.

=head2 C<free( $ptr )>

Deallocates the space previously allocated by C<malloc( ... )>, C<calloc( ...
)> or C<realloc( ... )>.

    free( $value2 );

=head2 C<memchr( $ptr, $ch, $count )>

Finds the first occurrence of (C<unsigned char>) C<$ch> in the initial
C<$count> bytes (each interpreted as C<unsigned char>) of the object pointed to
by C<$ptr>.

=head2 C<memcmp( $lhs, $rhs, $count )>

Compares the first C<$count> bytes of the objects pointed to by C<$lhs> and
C<$rhs>. The comparison is done lexicographically.

Returns a negative value if C<$lhs> appears before C<$rhs> in lexicographical
order.

Returns zero if C<$lhs> and C<$rhs> compare equal or if C<$count> is zero.

Returns a positive value if C<$lhs> appears after C<$rhs> in lexicographical
order.

=head2 C<memset( $dest, $ch, $count )>

Copies the value (C<unsigned char>) C<$ch> into each of the first C<$count>
characters of the object pointed to by C<$dest>.

    memset( $ptr, 'a', 5 );

Returns a copy of C<$dest>.

=head2 C<memcpy( $dest, $src, $count )>

Copies C<$count> characters from the object pointed to by C<$src> to the object
pointed to by C<$dest>. Both objects are interpreted as arrays of C<unsigned
char>.

Returns a copy of C<$dest>.

=head2 C<memmove( $dest, $src, $count )>

Copies C<$count> characters from the object pointed to by C<$src> to the object
pointed to by C<$dest>. Both objects are interpreted as arrays of C<unsigned
char>. The objects may overlap: copying takes place as if the characters were
copied to a temporary character array and then the characters were copied from
the array to C<$dest>.

Returns a copy of C<$dest>.

=head1 LICENSE

Copyright (C) Sanko Robinson.

This library is free software; you can redistribute it and/or modify it under
the terms found in the Artistic License 2. Other copyrights, terms, and
conditions may apply to data transmitted through this module.

=head1 AUTHOR

Sanko Robinson E<lt>sanko@cpan.orgE<gt>

=begin stopwords

dyncall const deallocated

=end stopwords

=cut

=pod

=encoding utf-8

=head1 NAME

Dyn::Call::Aggregate - C interface to compute struct size

=head1 DESCRIPTION

It's a void pointer. Make whatever you want with it.

=head1 Functions


=head1 LICENSE

Copyright (C) Sanko Robinson.

This library is free software; you can redistribute it and/or modify it under
the terms found in the Artistic License 2. Other copyrights, terms, and
conditions may apply to data transmitted through this module.

=head1 AUTHOR

Sanko Robinson E<lt>sanko@cpan.orgE<gt>

=begin stopwords

dyncall const deallocated

=end stopwords

=cut
